#! /usr/bin/python
# -*- coding: UTF-8 -*-

#==============================================================================#
# Dateiname:    gnome-themer                                                   #
# Version:      2.1                                                            #
# Datum:        18.12.2004                                                     #
# Lizenz:       GPL                                                            #
# Autor:        Marcus Habermehl <bmh1980de@yahoo.de>                          #
#==============================================================================#

# Module importieren
import gettext, gobject, gtk, os

gettext.install('gnome-themer', localedir = '../locale', unicode = True)

# Globale Variabeln
HOME = os.getenv('HOME')
GTKRC = HOME+'/.gtkrc'
GTK2RC = HOME+'/.gtkrc-2.0'
ICONDIR = HOME+'/.icons/default'
CURSORS = HOME+'/.icons/default/cursors'
Backgrd_Dirs = [HOME+'/.backgrounds',
                HOME+'/.gnome2/wallpapers',
                HOME+'/.wallpapers',
                '/opt/gnome/share/pixmaps/wallpapers',
                '/opt/gnome/share/wallpapers',
                '/usr/local/share/pixmaps/wallpapers',
                '/usr/local/share/wallpapers',
                '/usr/share/pixmaps/wallpapers',
                '/usr/share/wallpapers']
Icon_Dirs = [HOME+'/.icons',
             '/opt/gnome/share/icons',
             '/usr/local/share/icons',
             '/usr/share/icons']
Mouse_Dirs = ['/usr/X11R6/lib/X11/icons']
Theme_Dirs = [HOME+'/.themes',
              '/opt/gnome/share/themes',
              '/usr/local/share/themes',
              '/usr/share/themes']
Splash_Dirs = [HOME+'/.gnome2/splash',
               HOME+'/.icons/splash',
               '/opt/gnome/share/pixmaps/splash',
               '/usr/local/share/pixmaps/splash',
               '/usr/share/pixmaps/splash']
cellrenderer1 = gtk.CellRendererText()

# About-Dialog
def About(*args):
    window2 = gtk.Window()
    window2.set_icon(gtk.gdk.pixbuf_new_from_file('gtk2.png'))
    window2.set_title(_('Abot Gnome Themer 2.1')) # gettext
    window2.set_border_width(12)
    vbox2 = gtk.VBox()
    vbox2.set_spacing(12)
    image8 = gtk.Image()
    image8.set_from_file('gtk2.png')
    label8 = gtk.Label()
    label8.set_text('<span size="xx-large" weight="bold">Gnome Themer 2.1</span>')
    label8.set_use_markup(True)
    label9 = gtk.Label()
    label9.set_text(_('Select background wallpapers, GTK-1, GTK-2, icon, \
metacity, cursor themes or splash screens.')) # gettext
    label9.set_line_wrap(True)
    label9.set_justify(gtk.JUSTIFY_CENTER)
    label10 = gtk.Label()
    label10.set_text('<span size="small">© 2004 Marcus Habermehl</span>')
    label10.set_use_markup(True)
    hbuttonbox2 = gtk.HButtonBox()
    button3 = gtk.Button()
    button3.set_label('gtk-about')
    button3.set_use_stock(True)
    button3.connect('clicked', Credits)
    button4 = gtk.Button()
    button4.set_label('gtk-close')
    button4.set_use_stock(True)
    button4.connect('clicked', lambda button4: window2.destroy())
    for item in [button3, button4]:
        hbuttonbox2.add(item)
    for item in [image8, label8, label9, label10, hbuttonbox2]:
        vbox2.pack_start(item)
    window2.add(vbox2)
    window2.show_all()

# Credits
def Credits(*args):
    window3 = gtk.Window()
    window3.set_title(_('Credits')) # gettext
    window3.set_icon(gtk.gdk.pixbuf_new_from_file('gtk2.png'))
    window3.set_modal(True)
    window3.set_border_width(12)
    vbox3 = gtk.VBox()
    vbox3.set_spacing(12)
    notebook1 = gtk.Notebook()
    notebook1.set_size_request(330, 195)
    scrolledwindow1 = gtk.ScrolledWindow()
    scrolledwindow1.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    viewport1 = gtk.Viewport()
    viewport1.set_shadow_type(gtk.SHADOW_NONE)
    viewport1.set_border_width(12)
    scrolledwindow1.add(viewport1)
    label11 = gtk.Label(_('Written by')) # gettext
    notebook1.append_page(scrolledwindow1, tab_label = label11)
    label12 = gtk.Label()
    label12.set_text('Marcus Habermehl <bmh1980de@yahoo.de>')
    label12.set_alignment((0.0-1.0), (0.0-1.0))
    label12.set_selectable(True)
    viewport1.add(label12)
    scrolledwindow2 = gtk.ScrolledWindow()
    scrolledwindow2.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    viewport2 = gtk.Viewport()
    viewport2.set_shadow_type(gtk.SHADOW_NONE)
    viewport2.set_border_width(12)
    scrolledwindow2.add(viewport2)
    label13 = gtk.Label(_('Translated by')) # gettext
    notebook1.append_page(scrolledwindow2, tab_label = label13)
    label14 = gtk.Label()
    label14.set_text('Marcus Habermehl <bmh1980de@yahoo.de>')
    label14.set_alignment((0.0-1.0), (0.0-1.0))
    label14.set_selectable(True)
    viewport2.add(label14)
    hbuttonbox3 = gtk.HButtonBox()
    hbuttonbox3.set_layout(gtk.BUTTONBOX_END)
    button5 = gtk.Button()
    button5.set_label('gtk-close')
    button5.set_use_stock(True)
    button5.connect('clicked', lambda button3: window3.destroy())
    hbuttonbox3.add(button5)
    for item in [notebook1, hbuttonbox3]:
        vbox3.pack_start(item)
    window3.add(vbox3)
    window3.show_all()

# Funktion zum Ändern des Hintergrundbildes
def Background(*args):
    text = liste1[combobox1.get_active()]
    for directory in Backgrd_Dirs:
        if os.access(directory+'/'+text, os.F_OK):
            os.system('gconftool-2 --set \
                      /desktop/gnome/background/picture_filename \
                      --type=string "'+directory+'/'+text+'"')

def Options(*args):
    text = liste2[combobox2.get_active()]
    os.system('gconftool-2 --set /desktop/gnome/background/picture_options \
              --type=string "'+text+'"')

# Funktion zum Ändern des GTK1-Themes
def GTK1(*args):
    text = liste3[combobox3.get_active()]
    if os.access(GTKRC, os.F_OK):
        if os.path.isfile(GTKRC):
            os.rename(GTKRC, GTKRC+'~')
        elif os.path.islink(GTKRC):
            os.remove(GTKRC)
    for directory in Theme_Dirs:
        if os.access(directory+'/'+text, os.F_OK):
            os.symlink(directory+'/'+text+'/gtk/gtkrc', GTKRC)
            break

# Funktion zum Ändern des GTK2-Themes
def GTK2(*args):
    text = liste4[combobox4.get_active()]
    os.system('gconftool-2 --set /desktop/gnome/interface/gtk_theme \
              --type=string "'+text+'"')
    if os.access(GTK2RC, os.F_OK):
        if os.path.isfile(GTK2RC):
            os.rename(GTK2RC, GTK2RC+'~')
        elif os.path.islink(GTK2RC):
            os.remove(GTK2RC)
    for directory in Theme_Dirs:
        if os.access(directory+'/'+text, os.F_OK):
            os.symlink(directory+'/'+text+'/gtk-2.0/gtkrc', GTK2RC)
            break

# Funktion zum Ändern des Icon-Themes
def Icon(*args):
    text = liste5[combobox5.get_active()]
    os.system('gconftool-2 --set /desktop/gnome/interface/icon_theme \
              --type=string "'+text+'"')

# Funktion zum Ändern des Metacity-Themes
def Metacity(*args):
    text = liste6[combobox6.get_active()]
    os.system('gconftool-2 --set /apps/metacity/general/theme --type=string "'+
              text+'"')

# Funktionen zum Ändern des Maus-Themes
def Mouse(*args):
    text = liste7[combobox7.get_active()]
    if os.access(CURSORS, os.F_OK):
        if os.path.islink(CURSORS):
            os.remove(CURSORS)
        else:
            os.rename(CURSORS, CURSORS+'~')
    if not os.access(ICONDIR, os.F_OK):
        os.makedirs(ICONDIR)
    for directory in Mouse_Dirs:
        if os.access(directory+'/'+text, os.F_OK):
            os.symlink(directory+'/'+text+'/cursors', CURSORS)
            break

# Funktion zum Ändern des Splash-Screens
def Splash(*args):
    text = lsite8[combobox8.get_active()]
    os.system('gconftool-2 --set /apps/gnome-session/options/splash_image \
              --type=string splash/'+text)

# Programm beenden
def Quit(*args):
    gtk.main_quit()

# Fenster
window1 = gtk.Window()
window1.set_title('Gnome Themer 2.1')
window1.set_border_width(12)
window1.set_resizable(False)
window1.set_icon(gtk.gdk.pixbuf_new_from_file('gtk2.png'))
window1.set_position(gtk.WIN_POS_CENTER)
window1.connect('destroy', lambda window1: gtk.main_quit())

# Vertikale Box
vbox1 = gtk.VBox()
vbox1.set_spacing(12)

# Tabelle
table1 = gtk.Table()
table1.set_col_spacings(12)
table1.set_row_spacings(12)

# Zeile Hintergrund
image1 = gtk.Image()
image1.set_from_file('background.png')
label1 = gtk.Label(_('_Background')) # gettext
label1.set_use_underline(True)
hbox1 = gtk.HBox()
hbox1.set_spacing(12)
liststore1 = gtk.ListStore(gobject.TYPE_STRING)
combobox1 = gtk.ComboBox(liststore1)
label1.set_mnemonic_widget(combobox1)
combobox1.pack_start(cellrenderer1)
combobox1.add_attribute(cellrenderer1, 'text', 0)
liste1 = []
for directory in Backgrd_Dirs:
    if os.access(directory, os.F_OK):
        for item in os.listdir(directory):
            liste1.append(item)
liste1.sort()
for item in liste1:
    print _('Adding ')+item+_(' to backgrounds ...') # gettext
    combobox1.append_text(item)
INDEX = 0
IS = os.popen('gconftool-2 --get /desktop/gnome/background/picture_filename')
IS = os.path.basename(IS.readline().rstrip())
for item in liste1:
    if IS == liste1[INDEX]:
        combobox1.set_active(INDEX)
        break
    else:
        INDEX = INDEX + 1
combobox1.connect('changed', Background)
liststore2 = gtk.ListStore(gobject.TYPE_STRING)
combobox2 = gtk.ComboBox(liststore2)
combobox2.pack_start(cellrenderer1)
combobox2.add_attribute(cellrenderer1, 'text', 0)
liste2 = ['centered', 'none', 'scaled', 'stretched', 'wallpaper']
for item in liste2:
    combobox2.append_text(item)
INDEX = 0
IS = os.popen('gconftool-2 --get /desktop/gnome/background/picture_options')
IS = IS.readline().rstrip()
for item in liste2:
    if IS == liste2[INDEX]:
        combobox2.set_active(INDEX)
        break
    else:
        INDEX = INDEX + 1
combobox2.connect('changed', Options)
for item in [combobox1, combobox2]:
    hbox1.pack_start(item)
table1.attach(image1, 0, 1, 0, 1)
table1.attach(label1, 1, 2, 0, 1)
table1.attach(hbox1, 2, 3, 0, 1)

# Zeile Gtk-1
image2 = gtk.Image()
image2.set_from_file('gtk1.png')
label2 = gtk.Label('GTK-_1')
label2.set_use_underline(True)
liststore3 = gtk.ListStore(gobject.TYPE_STRING)
combobox3 = gtk.ComboBox(liststore3)
combobox3.pack_start(cellrenderer1)
combobox3.add_attribute(cellrenderer1, 'text', 0)
label2.set_mnemonic_widget(combobox3)
liste3 = []
for directory in Theme_Dirs:
    if os.access(directory, os.F_OK):
        for item in [x[0].split('/') [-1] for x in os.walk(directory) if 'gtk'
        in x[1]]:
            liste3.append(item)
liste3.sort()
for item in liste3:
    print _('Adding ')+item+_(' to GTK-1 themes ...') # gettext
    combobox3.append_text(item)
INDEX = 0
IS = os.path.basename(os.path.dirname(os.path.dirname(os.path.realpath(GTKRC))))
for item in liste3:
    if IS == liste3[INDEX]:
        combobox3.set_active(INDEX)
        break
    else:
        INDEX = INDEX + 1
combobox3.connect('changed', GTK1)
table1.attach(image2, 0, 1, 1, 2)
table1.attach(label2, 1, 2, 1, 2)
table1.attach(combobox3, 2, 3, 1, 2)

# Zeile Gtk-2
image3 = gtk.Image()
image3.set_from_file('gtk2.png')
label3 = gtk.Label('GTK-_2')
label3.set_use_underline(True)
liststore4 = gtk.ListStore(gobject.TYPE_STRING)
combobox4 = gtk.ComboBox(liststore4)
combobox4.pack_start(cellrenderer1)
combobox4.add_attribute(cellrenderer1, 'text', 0)
label3.set_mnemonic_widget(combobox4)
liste4 = []
for directory in Theme_Dirs:
    if os.access(directory, os.F_OK):
        for item in [x[0].split('/') [-1] for x in os.walk(directory) if
        'gtk-2.0' in x[1]]:
            liste4.append(item)
liste4.sort()
for item in liste4:
    print _('Adding ')+item+_(' to GTK-2 themes ...') # gettext
    combobox4.append_text(item)
INDEX = 0
IS = os.popen('gconftool-2 --get /desktop/gnome/interface/gtk_theme')
IS = IS.readline().rstrip()
for item in liste4:
    if IS == liste4[INDEX]:
        combobox4.set_active(INDEX)
        break
    else:
        INDEX = INDEX + 1
combobox4.connect('changed', GTK2)
table1.attach(image3, 0, 1, 2, 3)
table1.attach(label3, 1, 2, 2, 3)
table1.attach(combobox4, 2, 3, 2, 3)

# Zeile Icon
image4 = gtk.Image()
image4.set_from_file('icon.png')
label4 = gtk.Label(_('_Icon')) # gettext
label4.set_use_underline(True)
liststore5 = gtk.ListStore(gobject.TYPE_STRING)
combobox5 = gtk.ComboBox(liststore5)
combobox5.pack_start(cellrenderer1)
combobox5.add_attribute(cellrenderer1, 'text', 0)
label4.set_mnemonic_widget(combobox5)
liste5 = []
for directory in Icon_Dirs:
    if os.access(directory, os.F_OK):
        for item in [x[0].split('/') [-1] for x in os.walk(directory) if
        'index.theme' in x[-1]]:
            liste5.append(item)
liste5.sort()
for item in liste5:
    print _('Adding ')+item+_(' to icon themes ...') # gettext
    combobox5.append_text(item)
INDEX = 0
IS = os.popen('gconftool-2 --get /desktop/gnome/interface/icon_theme')
IS = IS.readline().rstrip()
for item in liste5:
    if IS == liste5[INDEX]:
        combobox5.set_active(INDEX)
        break
    else:
        INDEX = INDEX + 1
combobox5.connect('changed', Icon)
table1.attach(image4, 0, 1, 4, 5)
table1.attach(label4, 1, 2, 4, 5)
table1.attach(combobox5, 2, 3, 4, 5)

# Zeile Metacity
image5 = gtk.Image()
image5.set_from_file('metacity.png')
label5 = gtk.Label('_Metacity')
label5.set_use_underline(True)
liststore6 = gtk.ListStore(gobject.TYPE_STRING)
combobox6 = gtk.ComboBox(liststore6)
combobox6.pack_start(cellrenderer1)
combobox6.add_attribute(cellrenderer1, 'text', 0)
label5.set_mnemonic_widget(combobox6)
liste6 = []
for directory in Theme_Dirs:
    if os.access(directory, os.F_OK):
        for item in [x[0].split('/') [-1] for x in os.walk(directory) if
        'metacity-1' in x[1]]:
            liste6.append(item)
liste6.sort()
for item in liste6:
    print _('Adding ')+item+_(' to metacity themes ...') # gettext
    combobox6.append_text(item)
INDEX = 0
IS = os.popen('gconftool-2 --get /apps/metacity/general/theme')
IS = IS.readline().rstrip()
for item in liste6:
    if IS == liste6[INDEX]:
        combobox6.set_active(INDEX)
        break
    else:
        INDEX = INDEX + 1
combobox6.connect('changed', Metacity)
table1.attach(image5, 0, 1, 5, 6)
table1.attach(label5, 1, 2, 5, 6)
table1.attach(combobox6, 2, 3, 5, 6)

# Zeile Mouse
image6 = gtk.Image()
image6.set_from_file('mouse.png')
label6 = gtk.Label(_('_Cursor')) # gettext
label6.set_use_underline(True)
liststore7 = gtk.ListStore(gobject.TYPE_STRING)
combobox7 = gtk.ComboBox(liststore7)
combobox7.pack_start(cellrenderer1)
combobox7.add_attribute(cellrenderer1, 'text', 0)
label6.set_mnemonic_widget(combobox7)
liste7 = []
for directory in Mouse_Dirs:
    if os.access(directory, os.F_OK):
        for item in os.listdir(directory):
            liste7.append(item)
liste7.sort()
for item in liste7:
    print _('Adding ')+item+_(' to cursor themes ...') # gettext
    combobox7.append_text(item)
INDEX = 0
IS = os.path.basename(os.path.dirname(os.path.realpath(CURSORS)))
for item in liste7:
    if IS == liste7[INDEX]:
        combobox7.set_active(INDEX)
        break
    else:
        INDEX = INDEX + 1
combobox7.connect('changed', Mouse)
table1.attach(image6, 0, 1, 6, 7)
table1.attach(label6, 1, 2, 6, 7)
table1.attach(combobox7, 2, 3, 6, 7)

# Zeile Splash-Screen
image7 = gtk.Image()
image7.set_from_file('splash.png')
label7 = gtk.Label(_('_Splash screen')) # gettext
label7.set_use_underline(True)
liststore8 = gtk.ListStore(gobject.TYPE_STRING)
combobox8 = gtk.ComboBox(liststore8)
combobox8.pack_start(cellrenderer1)
combobox8.add_attribute(cellrenderer1, 'text', 0)
label7.set_mnemonic_widget(combobox8)
liste8 = []
for directory in Splash_Dirs:
    if os.access(directory, os.F_OK):
        for item in os.listdir(directory):
            liste8.append(item)
liste8.sort()
for item in liste8:
    print _('Adding ')+item+_(' to splash screens ...') # gettext
    combobox8.append_text(item)
INDEX = 0
IS = os.popen('gconftool-2 --get /apps/gnome-session/options/splash_image')
IS = IS.readline().rstrip().replace('splash/', '')
for item in liste8:
    if IS == liste8[INDEX]:
        combobox8.set_active(INDEX)
        break
    else:
        INDEX = INDEX + 1
combobox8.connect('changed', Splash)
table1.attach(image7, 0, 1, 7, 8)
table1.attach(label7, 1, 2, 7, 8)
table1.attach(combobox8, 2, 3, 7, 8)

# Stock-Icon für den Credits-Button
gtk.stock_add((('gtk-about', _('_Credits'), # gettext
                gtk.gdk.MOD1_MASK, gtk.gdk.keyval_from_name(_('C')), 'gtk20'),))
                # gettext
iconfactory1 = gtk.IconFactory()
pixbuf1 = gtk.gdk.pixbuf_new_from_file(_('gtk-about.png')) # gettext
iconset1 = gtk.IconSet(pixbuf1)
iconfactory1.add('gtk-about', iconset1)
iconfactory1.add_default()

hbuttonbox1 = gtk.HButtonBox()
button1 = gtk.Button()
button1.set_label('gtk-about')
button1.set_use_stock(True)
button1.connect('clicked', About)
button2 = gtk.Button()
button2.set_label('gtk-quit')
button2.set_use_stock(True)
button2.connect('clicked', Quit)

for item in [button1, button2]:
    hbuttonbox1.add(item)

for item in [table1, hbuttonbox1]:
    vbox1.pack_start(item)

accelgroup = gtk.AccelGroup()
key, modifier = gtk.accelerator_parse('<Control>q')
accelgroup.connect_group(key, modifier, gtk.ACCEL_VISIBLE,
                         Quit)
window1.add_accel_group(accelgroup)

window1.add(vbox1)
window1.show_all()
gtk.main()
